//18.01.2022//03.03.2020
//ESP 8266 //
#include "FS.h"  // lib für Filesystem 
#include <ESP8266WebServer.h>
//#include <WiFi.h>    
#include <WiFiUdp.h>
#include <ArduinoOTA.h>
#include <Wire.h>
//#include <LiquidCrystal_I2C.h>
//LiquidCrystal_I2C LCD(0x27, 20, 4);
#include <NoiascaLiquidCrystal.h>      // use the library downloaded from https://werner.rothschopf.net/202009_arduino_liquid_crystal_intro.htm/
#include <NoiascaHW/lcd_PCF8574.h> 
const byte cols = 20;                  // columns/characters per row
const byte rows = 4;                   // how many rows
const byte addr = 0x27;                // set the LCD address to 0x3F or 0x27

//LiquidCrystal_PCF8574 lcd(addr, cols, rows);               // create lcd object - with support of special characters
LiquidCrystal_PCF8574_base LCD(addr, cols, rows); 

#include <OneWire.h>
#include <DallasTemperature.h>
// Data wire is plugged into port 2 on the Arduino
#define ONE_WIRE_BUS 0 // GPIO 0 (WAKE D0)
#define TEMPERATURE_PRECISION 12
// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);
DeviceAddress sensor1 = {0x28, 0x5, 0x50, 0x56, 0xB5, 0x1, 0x3C, 0xE1 };//Auußen
DeviceAddress sensor2 = {0x28, 0x1F, 0xAC, 0x75, 0xD0, 0x1, 0x3C, 0x9A };//Innen

#include <RTClib.h>
RTC_DS3231 rtc;

//const char* ssid = " ";
//const char* password = " ";


const char* sid = "ESP"; // http://192.168.4.1
const char* pass = "";

#include <SPI.h>
#include<SD.h>
File dataFile;
//time_t now;     // this is the epoch
//tm tm;

#include <IRremote.h>
IRrecv irrecv(16); // Ausgangs-Pin von TSOP4838 (IR) DO
decode_results results;

//ADC_MODE(ADC_VCC);

// Server Instanz erstellen
ESP8266WebServer server(80);
unsigned long ulReqcount;//???
//WiFiServer server(80);

char WochenTag[7][3] = {"So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"};
char monat[13][4] = {"", "Jan", "Feb", "M\341r", "Apr", "Mai", "Jun", "Jul", "Aug", "Sep", "Okt", "Now", "Dez"};
char Monat[13][10] = {"", "Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"};
/* Globals */
//time_t now;     // this is the epoch
//tm tm;       // the structure tm holds time information in a more convient way

#include <ModbusMaster.h>
/*!
  We"re using a MAX485-compatible RS485 Transceiver.
  Rx/Tx is hooked up to the hardware serial port at "Serial".
  The Data Enable and Rec3eiver Enable pins are hooked up as follows:

   Ich verwend einen MAX485-kompatiblen RS485-Transceiver.
  Rx/Tx ist mit der seriellen Schnittstelle der Hardware an "Serial" verbunden.
  Die Pins "Data Enable" und "Rec3eiver Enable" sind wie folgt beschaltet:
*/
#define MAX485_DE 2 //  DE und RE Pins auf GPIO2 (D4) 
#define MAX485_RE_NEG  2 // 
//Ppin DI auf GPIO 1(TXD0)
//Pin  RO auf GPIO 3(RXDO)
//Serial Monitor wird nicht benutzt!!!
// instantiate ModbusMaster object
ModbusMaster node;
void preTransmission()
{
  digitalWrite(MAX485_RE_NEG, 1);
  digitalWrite(MAX485_DE, 1);
}
void postTransmission()
{
  digitalWrite(MAX485_RE_NEG, 0);
  digitalWrite(MAX485_DE, 0);
}
unsigned long previousMillis = 0;
const long intervall = 2000;

const long interval = 3000;//720000
void setup() {
  Serial.begin(112600);
  //WiFi.mode(WIFI_STA);
  //WiFi.begin(ssid, password);
  WiFi.mode(WIFI_AP);
  WiFi.softAP(sid, pass);

  // myRTC.begin();
  //  setupTime();
  irrecv.enableIRIn();

  LCD.begin(4, 5); //lcd.begin(sda,scl) D1,D2
  LCD.backlight();
  LCD.clear();

  SD.begin (15);//D8

  if (!SD.begin(15)) {
    LCD.setCursor(3, 0);
    LCD.print (F (" SD Karte fehlt "));
    LCD.setCursor(3, 1);
    LCD.print(F(" Karte einlegen"));
    LCD.setCursor(0, 2);
    LCD.println(F ("Kein Datalog!!!"));
    delay(8000);
  }
  else {
    LCD.setCursor(3, 0);
    LCD.print (F (" SD Karte OK "));
    LCD.setCursor(0, 2);
    LCD.println(F (" Datalog begint"));
  }
  delay(2000);
  LCD.clear();

  pinMode(MAX485_RE_NEG, OUTPUT);
  pinMode(MAX485_DE, OUTPUT);
  // Init in receive mode
  digitalWrite(MAX485_RE_NEG, 0);
  digitalWrite(MAX485_DE, 0);
  // Modbus communication runs at 115200 baud
  // // Modbus slave ID 1 = Tracer Adresse
  node.begin(1, Serial);
  // Callbacks allow us to configure the RS485 transceiver correctly
  node.preTransmission(preTransmission);
  node.postTransmission(postTransmission);
  ArduinoOTA.begin();

  SPIFFS.begin(); // Filesystem starten
  // --Server Handle einrichten---
  server.serveStatic("/", SPIFFS, "/index.html");

  server.begin();
  server.on("/daten", sendeDaten);
  server.onNotFound(handleNotFound);   // Fehler bearbeiten

  server.begin();
}



void loop()
{
  ArduinoOTA.handle();
  LCDanzeige();
  datalog();
  server.handleClient();// hier passiert sonst nichts
  //IR /////
  unsigned int IRwert = results.value;
  if (irrecv.decode(&results)) {
    irrecv.decode(&results);
   // Serial.println(IRwert);
    irrecv.resume();
  }
}/// *** void loop ende ***//

// ------------ Fehler Seite
void handleNotFound() {
  String message = "File Not Found\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message += (server.method() == HTTP_GET) ? "GET" : "POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";
  for (uint8_t i = 0; i < server.args(); i++) {
    message += " " + server.argName(i) + ": " + server.arg(i) + "\n";
  }
  server.send(404, "text/plain", message);
}// Fehler Seite Ende//

/// Daten senden Tag, Monat, Jahr PV Werte ////
void sendeDaten() {
  char sendbuffer[400];

  DateTime now = rtc.now();
  //  time(&now);             // read the current time
  // localtime_r(&now, &tm);    // update the structure tm with the current time
  byte wtag = now.dayOfTheWeek();
  byte tag = now.day();
  byte mon = now.month();
  int jahr = now.year();
  byte stunden = now.hour();
  char* jetztMonat = (Monat[mon]);
  char* wochenTag = (WochenTag[wtag]);
  byte minuten = now.minute();
  byte sek = now.second();

  float Voltesp1 = ESP.getVcc();
  float Voltesp = Voltesp1 / 1000;
  //PV Daten
  uint8_t result;
  result = node.readInputRegisters(0x3110, 1);// Akku temp
  if (result == node.ku8MBSuccess) {
    float akkuTemp = node.getResponseBuffer(0x00) / 100.0f;

    result = node.readInputRegisters(0x3100, 16);// 16 Stellen im Register 3100 auslesen
    if (result == node.ku8MBSuccess)
    {
      float pvVolt = node.getResponseBuffer(0x00) / 100.0f; //Tracer PV Volt
      float pvAmpere = node.getResponseBuffer(0x01) / 100.0f;//PV Ampere
      float pvWat = ((node.getResponseBuffer(0x02) +  node.getResponseBuffer(0x03) ) / 100.0f); //PV Watt
      float akkuVolt = node.getResponseBuffer(0x04) / 100.0f;
      float akkuAmpere = node.getResponseBuffer(0x05) / 100.0f;
      float akkuleist = ((node.getResponseBuffer(0x06) +  node.getResponseBuffer(0x07) ) / 100.0f); //Akku Watt

      // JSON String als Array anlegen
      result = node.readInputRegisters(0x3111 , 1); //Akkukapazität in Prozent
      if (result == node.ku8MBSuccess) {
        float systemTemp = node.getResponseBuffer(0x00) / 100.0f;

        result = node.readInputRegisters(0x311A , 1); //Akkukapazität in Prozent
        if (result == node.ku8MBSuccess) {
          int akkuProzente = node.getResponseBuffer(0x00);
          result = node.readInputRegisters(0x3300 , 20); //PV Leistung
          float pvKWhges  = ((node.getResponseBuffer(0x12) +  node.getResponseBuffer(0x13) ) / 100.0f); //PV Watt
          float pvKWhges1 = pvKWhges + 115.8;
          float pvKWhtag = ((node.getResponseBuffer(0x0C) +  node.getResponseBuffer(0x0D) ) / 100.0f); //PV Watt
          float pvKWhmon = ((node.getResponseBuffer(0x0E) +  node.getResponseBuffer(0x0F) ) / 100.0f); //PV Watt

          float temp3 = sensors.getTempC(sensor2);
          float temp4 = sensors.getTempC(sensor1);
          temp4 = temp4 - 0.3;
          ///printf("Ein Datum: %02d.%02d.%4d\n", tag, monat, jahr);//eine 0 vor minute
          // sprintf(sendbuffer, "[\"%02d.\",\"%2d.\", \"%4d\",  \"%4i\",\"%4.1f\",\"%3i\",\"%5i\",\"%2i\",\"%3i\",\"%3i\",\"%02d\",\"%3i\",\"%02d\" ]",
          //       wochenTag, tag,  jetztMonat, jahr, tempBME, feuchteBME, druckBME, ndif, zeigemin, aufgangStunden, aufgangMinuten, untergangStunden, untergangMinuten  );

          sprintf(sendbuffer, "[\"%s\",\"%2d \",\"%s\", \"%4d\",\"%02d :\",\"%02d  \",\"%4.1f\",\"%4.1f\",\"%4.1f\",\"%4.1f\",\"%4.1f\",\"%4.1f\",\"%4.1f\",\"%3i\",\"%4.2f\",\"%4.2f\",\"%4.2f\",\"%3.1f\",\"%4.1f\",\"%3.1f\",\"%4.3f\"]",
                  wochenTag, tag,   jetztMonat, jahr, stunden, minuten, temp3, temp4, pvVolt, pvAmpere, pvWat, akkuVolt, akkuAmpere, akkuProzente, pvKWhges1, pvKWhtag, pvKWhmon, akkuTemp, akkuleist, systemTemp, pvKWhges  );
        }
      }
    }
  }


  ///printf("Ein Datum: %02d.%02d.%4d\n", tag, monat, jahr);//Beispiel 08.05.2021
  server.send(200, "application/json", sendbuffer);

} ///Sensden Ende///


// ----- String to float mit Komma tausch -----------
float StringToFloat(String t) {
  t.replace(",", ".");
  return t.toFloat();
}
